#include <stdint.h>
#include <stdio.h>
#include <pwmss.h>

int main(void){
    if(bbb_pwmss_init()){
        fprintf(stderr, "Can not initialize pwmss lib\n");
        return(1);
    }
    ecap_reg *ECAP = (ecap_reg *)(PWMSS[0]+eCAP_off);

    // Set ECCTL1
    ECAP->ECCTL1 = (uint16_t)0;                         // Set 0x48300128 to 0x0
    // Set ECCTL2
    ECAP->ECCTL2 = (uint16_t)(F_CAP_APWM|F_TSCTRRUN);   // Set 0x4830012A to 0x110
    // Set interrupt
    ECAP->ECEINT = (uint16_t)(F_CNTOVF|F_CEVT2);
    // Clear curent status
    ECAP->ECCLR = (uint16_t)0xffff;

    // period = 1msec, duty = 25%
    ECAP->CAP1 = 100000;
    ECAP->CAP2 = 25000;

    bbb_pwmss_free();
    return(0);
}
