#include <stdint.h>
#include <stdio.h>
#include <pwmss.h>

int main(void){
    if(bbb_pwmss_init()){
        fprintf(stderr, "Can not initialize pwmss lib\n");
        return(1);
    }
    ecap_reg *ECAP = (ecap_reg *)(PWMSS[0]+eCAP_off);

    // Set ECCTL1
    ECAP->ECCTL1 = (uint16_t)(F_CAPLDEN|F_CTRRST2);                              // Set 0x48300128 to 0x108
    // Set ECCTL2
    ECAP->ECCTL2 = (uint16_t)(F_TSCTRRUN|F_STOP_WRAP2|F_CONT_ONESHT|F_REARM);    // Set 0x4830012A to 0x13
    // Set interrupt
    ECAP->ECEINT = (uint16_t)(F_CNTOVF|F_CEVT2);
    // Clear curent status
    ECAP->ECCLR = (uint16_t)0xffff;

    while(1){
        if(ECAP->ECFLG & F_INT){
            if(ECAP->ECFLG & F_CNTOVF){ // counter over flow
                printf("0 Hz\n");
            }
            else{
                printf("%.2f Hz\n", (float)AM335x_PWMSS_CLK/(ECAP->CAP2 - ECAP->CAP1));
            }
            ECAP->ECCLR = (uint16_t)0xffff;
            ECAP->ECCTL2 |= (uint16_t)F_REARM;
        }
    }

    // not reach
    bbb_pwmss_free();
    return(0);
}
