#define _GNU_SOURCE
#include <stdint.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <sys/mman.h>
#include <pwmss.h>

uint8_t *PWMSS[3];

_Bool bbb_pwmss_init(void){
    int dev;
    if((dev = open("/dev/mem", O_RDWR|O_SYNC|O_LARGEFILE)) < 0){
        perror("open");
        return(1);
    }

    // enable PWMSS module
    uint32_t *CM_PER;
    if((CM_PER = mmap(0, AM335x_CM_PER_LEN, PROT_READ | PROT_WRITE, MAP_SHARED, dev, AM335x_CM_PER)) == MAP_FAILED){
        perror("Err: Can not map cm_per registers.");
        return(1);
    }
    CM_PER[CM_PER_EPWMSS0_CLKCTRL] = 0x2;
    CM_PER[CM_PER_EPWMSS1_CLKCTRL] = 0x2;
    CM_PER[CM_PER_EPWMSS2_CLKCTRL] = 0x2;
    munmap(CM_PER,AM335x_CM_PER_LEN);

    if((PWMSS[0] = mmap(0, AM335x_PWMSS_LEN, PROT_READ | PROT_WRITE, MAP_SHARED, dev, PWMSS0_base)) == MAP_FAILED){
        perror("Err: Can not map PSMSS0 registers.");
        return(1);
    }
    if((PWMSS[1] = mmap(0, AM335x_PWMSS_LEN, PROT_READ | PROT_WRITE, MAP_SHARED, dev, PWMSS1_base)) == MAP_FAILED){
        perror("Err: Can not map PSMSS1 registers.");
        return(1);
    }
    if((PWMSS[2] = mmap(0, AM335x_PWMSS_LEN, PROT_READ | PROT_WRITE, MAP_SHARED, dev, PWMSS2_base)) == MAP_FAILED){
        perror("Err: Can not map PSMSS2 registers.");
        return(1);
    }

    close(dev);
    return(0);
}

_Bool bbb_pwmss_free(void){
    for(uint8_t i=0; i<3; i++){
        munmap(PWMSS[i], AM335x_PWMSS_LEN);
    }
    return(0);
}
