#define AM335x_CM_PER       0x44E00000  // to 0x44E003FF
#define AM335x_CM_PER_LEN   0x600
extern uint8_t *PWMSS[3];

enum cm_per_reg_index {
    CM_PER_L4LS_CLKSTCTRL,		// 0h
    CM_PER_L3S_CLKSTCTRL,		// 4h
    CM_PER_DUMMY0,		        // 8h Gap
    CM_PER_L3_CLKSTCTRL,		// Ch
    CM_PER_DUMMY1,		        // 10h Gap
    CM_PER_CPGMAC0_CLKCTRL,		// 14h
    CM_PER_LCDC_CLKCTRL,		// 18h
    CM_PER_USB0_CLKCTRL,		// 1Ch
    CM_PER_DUMMY2,		        // 20h Gap
    CM_PER_TPTC0_CLKCTRL,		// 24h
    CM_PER_EMIF_CLKCTRL,		// 28h
    CM_PER_OCMCRAM_CLKCTRL,		// 2Ch
    CM_PER_GPMC_CLKCTRL,		// 30h
    CM_PER_MCASP0_CLKCTRL,		// 34h
    CM_PER_UART5_CLKCTRL,		// 38h
    CM_PER_MMC0_CLKCTRL,		// 3Ch
    CM_PER_ELM_CLKCTRL,		    // 40h
    CM_PER_I2C2_CLKCTRL,		// 44h
    CM_PER_I2C1_CLKCTRL,		// 48h
    CM_PER_SPI0_CLKCTRL,		// 4Ch
    CM_PER_SPI1_CLKCTRL,		// 50h
    CM_PER_DUMMY3,		        // 54h Gap
    CM_PER_DUMMY4,		        // 58h Gap
    CM_PER_DUMMY5,		        // 5Ch Gap
    CM_PER_L4LS_CLKCTRL,		// 60h
    CM_PER_DUMMY6,		        // 64h Gap
    CM_PER_MCASP1_CLKCTRL,		// 68h
    CM_PER_UART1_CLKCTRL,		// 6Ch
    CM_PER_UART2_CLKCTRL,		// 70h
    CM_PER_UART3_CLKCTRL,		// 74h
    CM_PER_UART4_CLKCTRL,		// 78h
    CM_PER_TIMER7_CLKCTRL,		// 7Ch
    CM_PER_TIMER2_CLKCTRL,		// 80h
    CM_PER_TIMER3_CLKCTRL,		// 84h
    CM_PER_TIMER4_CLKCTRL,		// 88h
    CM_PER_DUMMY7,		        // 8Ch Gap
    CM_PER_DUMMY8,		        // 90h Gap
    CM_PER_DUMMY9,		        // 94h Gap
    CM_PER_DUMMY10,		        // 98h Gap
    CM_PER_DUMMY11,		        // 9Ch Gap
    CM_PER_DUMMY12,		        // A0h Gap
    CM_PER_DUMMY13,		        // A4h Gap
    CM_PER_DUMMY14,		        // A8h Gap
    CM_PER_GPIO1_CLKCTRL,		// ACh
    CM_PER_GPIO2_CLKCTRL,		// B0h
    CM_PER_GPIO3_CLKCTRL,		// B4h
    CM_PER_DUMMY15,		        // B8h Gap
    CM_PER_TPCC_CLKCTRL,		// BCh
    CM_PER_DCAN0_CLKCTRL,		// C0h
    CM_PER_DCAN1_CLKCTRL,		// C4h
    CM_PER_DUMMY16,		        // C8h Gap
    CM_PER_EPWMSS1_CLKCTRL,		// CCh
    CM_PER_DUMMY17,		        // D0h Gap
    CM_PER_EPWMSS0_CLKCTRL,		// D4h
    CM_PER_EPWMSS2_CLKCTRL,		// D8h
    CM_PER_L3_INSTR_CLKCTRL,	// DCh
    CM_PER_L3_CLKCTRL,		    // E0h
    CM_PER_IEEE5000_CLKCTRL,	// E4h
    CM_PER_PRU_ICSS_CLKCTRL,	// E8h
    CM_PER_TIMER5_CLKCTRL,		// ECh
    CM_PER_TIMER6_CLKCTRL,		// F0h
    CM_PER_MMC1_CLKCTRL,		// F4h
    CM_PER_MMC2_CLKCTRL,		// F8h
    CM_PER_TPTC1_CLKCTRL,		// FCh
    CM_PER_TPTC2_CLKCTRL,		// 100h
    CM_PER_DUMMY18,		        // 104h Gap
    CM_PER_DUMMY19,		        // 108h Gap
    CM_PER_SPINLOCK_CLKCTRL,	// 10Ch
    CM_PER_MAILBOX0_CLKCTRL,	// 110h
    CM_PER_DUMMY20,		        // 114h Gap
    CM_PER_DUMMY21,		        // 118h Gap
    CM_PER_L4HS_CLKSTCTRL,		// 11Ch
    CM_PER_L4HS_CLKCTRL,		// 120h
    CM_PER_DUMMY22,		        // 124h Gap
    CM_PER_DUMMY23,		        // 128h Gap
    CM_PER_OCPWP_L3_CLKSTCTRL,	// 12Ch
    CM_PER_OCPWP_CLKCTRL,		// 130h
    CM_PER_DUMMY24,		        // 134h Gap
    CM_PER_DUMMY25,		        // 138h Gap
    CM_PER_DUMMY26,		        // 13Ch Gap
    CM_PER_PRU_ICSS_CLKSTCTRL,	// 140h
    CM_PER_DUMMY27,		        // 144h Gap
    CM_PER_LCDC_CLKSTCTRL,		// 148h
    CM_PER_CLKDIV32K_CLKCTRL,	// 14Ch
    CM_PER_CLK_24MHZ_CLKSTCTRL 	// 150h
};

#define AM335x_PWMSS_CLK   100000000   // 100MHz
#define AM335x_PWMSS_LEN   0x0260

#define PWMSS0_base 0x48300000
#define PWMSS1_base 0x48302000
#define PWMSS2_base 0x48304000

#define IDVER       0x0 //IP Revision Register
#define SYSCONFIG   0x4 //System Configuration Register
#define CLKCONFIG   0x8 //Clock Configuration Register
#define CLKSTATUS   0xC //Clock Status Register

// CLKCONFIG flag
#define F_PWMCLK_STOP_REQ   0b0000001000000000
#define F_PWMCLK_EN         0b0000000100000000
#define F_QEPCLK_STOP_REQ   0b0000000000100000
#define F_QEPCLK_EN         0b0000000000010000
#define F_CAPCLK_STOP_REQ   0b0000000000000010
#define F_CAPCLK_EN         0b0000000000000001

#define eCAP_off 0x100

// ECCTL1 flag
#define M_FREE_SOFT     0b1100000000000000
#define F_STOP_C_IMD    0b0000000000000000
#define F_STOP_C_ZERO   0b0100000000000000
#define M_PRESCALE      0b0011111000000000
#define F_CAPLDEN       0b0000000100000000
#define F_CTRRST4       0b0000000010000000
#define F_CAP4POL       0b0000000001000000
#define F_CTRRST3       0b0000000000100000
#define F_CAP3POL       0b0000000000010000
#define F_CTRRST2       0b0000000000001000
#define F_CAP2POL       0b0000000000000100
#define F_CTRRST1       0b0000000000000010
#define F_CAP1POL       0b0000000000000001

// ECCTL2 flag
#define F_APWMPOL       0b0000010000000000
#define F_CAP_APWM      0b0000001000000000
#define F_SWSYNC        0b0000000100000000
#define M_SYNCO_SEL     0b0000000011000000
#define F_SYNCO_PASS    0b0000000000000000
#define F_SYNCO_PRDEQ   0b0000000001000000
#define F_SYNCO_DIS     0b0000000011000000
#define F_SYNCI_EN      0b0000000000100000
#define M_TSCTRSTOP     0b0000000000010000
#define F_TSCTRRUN      0b0000000000010000
#define F_TSCTRSTOP     0b0000000000000000
#define F_REARM         0b0000000000001000
#define M_STOP_WRAP     0b0000000000000110
#define F_STOP_WRAP1    0b0000000000000000
#define F_STOP_WRAP2    0b0000000000000010
#define F_STOP_WRAP3    0b0000000000000100
#define F_STOP_WRAP4    0b0000000000000110
#define F_CONT_ONESHT   0b0000000000000001

// ECEINT, ECFLG and ECCLR flag
#define F_CMPEQ         0b10000000
#define F_PRDEQ         0b01000000
#define F_CNTOVF        0b00100000
#define F_CEVT4         0b00010000
#define F_CEVT3         0b00001000
#define F_CEVT2         0b00000100
#define F_CEVT1         0b00000010
#define F_INT           0b00000001

#pragma pack (2)
typedef struct { 
    volatile uint32_t TSCTR;
    volatile uint32_t CTRPS;
    volatile uint32_t CAP1;
    volatile uint32_t CAP2;
    volatile uint32_t CAP3;
    volatile uint32_t CAP4;
    volatile uint32_t GAP1;
    volatile uint32_t GAP2;
    volatile uint32_t GAP3;
    volatile uint32_t GAP4;
    volatile uint16_t ECCTL1;
    volatile uint16_t ECCTL2;
    volatile uint16_t ECEINT;
    volatile uint16_t ECFLG;
    volatile uint16_t ECCLR;
    volatile uint16_t ECFRC;
}ecap_reg;
extern struct ecap_reg *ECAP[3];
_Bool bbb_pwmss_init(void);
_Bool bbb_pwmss_free(void);
